"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseDoc = void 0;
const index_1 = require("../../../../index");
const fs = __importStar(require("fs"));
const helpers_1 = require("./helpers");
class DatabaseDoc {
    constructor(nameEnums) {
        this.nameEnums = nameEnums;
    }
    run() {
        const tables = [...(0, index_1.getMetadataTable)().getTables().values()];
        const enumDefinitionString = this.nameEnums ? (0, helpers_1.generateEnum)(this.nameEnums) : "";
        const schemaString = tables.reduce((target, item) => {
            target = `${target}${(0, helpers_1.generateTable)(item, this.nameEnums || [])}`;
            return target;
        }, "");
        const refString = (0, helpers_1.generateRef)((0, index_1.getMetadataRelationship)().getAll());
        const outputFile = "./database-doc.dbml";
        const content = enumDefinitionString + schemaString + refString;
        fs.writeFile(outputFile, content, "utf8", (err) => {
            if (err) {
                console.error(err);
                return;
            }
            // file written successfully
            console.log("success");
        });
    }
}
exports.DatabaseDoc = DatabaseDoc;
