"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.connectMongoDb = exports.collections = void 0;
const mongodb_1 = require("mongodb");
const metadata_1 = require("../../global/metadata");
const commons_1 = require("../../commons");
exports.collections = {};
const connectMongoDb = (config, isTest) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let dbUrl = `mongodb://`;
        if (config.username && config.password) {
            dbUrl += `${config.username}:${config.password}@`;
        }
        dbUrl += `${config.host}:${config.port}`;
        console.log(dbUrl);
        const mongodb = new mongodb_1.MongoClient(dbUrl);
        yield mongodb.connect();
        const db = mongodb.db(config.database);
        (0, metadata_1.getMetadataTable)().getTables().forEach((table) => {
            exports.collections[table.name] = db.collection(table.name);
        });
        if (!isTest) {
            console.log("****************************");
            console.log("*    Starting Server");
            console.log(`*    ${(0, commons_1.csuccess)(`DB:${dbUrl}/${config.database}`)}`);
            console.log(`*    ${(0, commons_1.csuccess)(`Type: mongodb`)}`);
            console.log(`*    ${(0, commons_1.csuccess)("DB Connection: OK")}`);
            console.log(`****************************`);
        }
        return db;
    }
    catch (error) {
        console.log(`*    ${(0, commons_1.cerror)(`Error connecting to DB: ${error}\n****************************`)}\n`);
        process.exit();
    }
});
exports.connectMongoDb = connectMongoDb;
