"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Middleware = void 0;
const constants_1 = require("../metadata/constants");
function Middleware(func) {
    return (target, key) => {
        const controllerClass = target.constructor;
        const middlewares = Reflect.hasMetadata(constants_1.MetadataKeys.MIDDLEWARE, controllerClass, key)
            ? Reflect.getMetadata(constants_1.MetadataKeys.MIDDLEWARE, controllerClass, key)
            : [];
        middlewares.push(func);
        Reflect.defineMetadata(constants_1.MetadataKeys.MIDDLEWARE, middlewares, controllerClass, key);
    };
}
exports.Middleware = Middleware;
