import { DBConnection } from "../connections/types";
import { AbstractSqlMigrator } from "./AbstractSqlMigrator";
import { MigrationModule } from "./utils";
export declare class SqlMigrator extends AbstractSqlMigrator {
    readonly connection: DBConnection;
    readonly dir: string;
    readonly metaTable: string;
    private readonly migrationModel;
    private readonly sequelize;
    constructor(connection: DBConnection, dir: string, metaTable?: string);
    initMigrationTables(queryInterface: any): Promise<void>;
    getAllMigrations(queryInterface: any): Promise<any[]>;
    migrate(modules: Record<string, MigrationModule>): Promise<void>;
    rollback(modules: Record<string, MigrationModule>, step?: number): Promise<void>;
    generateDBMetadata(outputFile: string): Promise<void>;
    execuseCommand(): Promise<void>;
}
