import { DataTypes, QueryInterface, Transaction } from "sequelize";
export interface MigrationModule {
    up: (queryInterface: QueryInterface, t: Transaction) => Promise<void>;
    down: (queryInterface: QueryInterface, t: Transaction) => Promise<void>;
}
export declare const MIGRATION_TEMPLATE = "\n    import { DataTypes, Sequelize } from \"sequelize\";\n    import type { QueryInterface, Transaction } from \"sequelize\";\n\n    export default {\n        up: async (queryInterface: QueryInterface, t: Transaction) => {\n            /** no-op */\n        },\n        down: async (queryInterface: QueryInterface, t: Transaction) => {\n            /** no-op */\n        },\n    };\n";
export declare const metaTableDefinition: {
    name: {
        primaryKey: boolean;
        allowNull: boolean;
        type: DataTypes.StringDataType;
    };
};
export declare enum MigratorCommand {
    GENERATE = "generate",
    UPGRADE = "up",
    DOWNGRADE = "down"
}
