import { ObjectId } from "mongodb";
import { WithRelation } from "./WithRelation";
import { FindOptions, KeyColumns, ModelQuery, QueryCondition } from "./QueryCondition";
import { QueryBuilder } from "..";
import { IPagination } from "../../global";
export interface IQueryBuilder<T> {
    withRelations: WithRelation<T, any>[];
    selectColumns: KeyColumns<T>;
    with<K>(params: WithRelation<T, K> | WithRelation<T, K>[], model: QueryBuilder<T>): any;
    findByPk(pk: ObjectId | string | number): Promise<ModelQuery<T> | null>;
    find(filter: QueryCondition<ModelQuery<T>>, options?: FindOptions<ModelQuery<T>>): Promise<ModelQuery<T>[]>;
    paginate(filter: QueryCondition<ModelQuery<T>>, paginate: IPagination, options?: FindOptions<ModelQuery<T>>): Promise<{
        data: ModelQuery<T>[];
        totalCount: number;
    }>;
    count(filter: QueryCondition<ModelQuery<T>>): Promise<number>;
    createOne(item: Partial<ModelQuery<T>>): Promise<ModelQuery<T>>;
    updateMany(filter: QueryCondition<ModelQuery<T>>, item: Partial<ModelQuery<T>>): any;
    deleteOne(filter: QueryCondition<ModelQuery<T>>): any;
    deleteMany(filter: QueryCondition<ModelQuery<T>>): any;
    select(selectColumns: KeyColumns<T>): any;
    reset(): any;
}
