"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerSocket = void 0;
const injector_1 = require("../../di/injector");
const authentication_1 = require("../../authentication");
class ServerSocket {
    constructor(socket, request) {
        const jwtService = injector_1.injector.get(authentication_1.JwtService);
        this.indentity = jwtService.verify(request.headers.token);
        this.socket = socket;
    }
    getId() {
        return this.socket.id;
    }
    getAuthInfo() {
        return this.indentity;
    }
    send(data, channel) {
        return __awaiter(this, void 0, void 0, function* () {
            this.socket.send(JSON.stringify(data));
        });
    }
    disconnect(err) {
        throw new Error('Method not implemented.');
    }
}
exports.ServerSocket = ServerSocket;
