import { WebSocketServer } from "ws";
import { RedisServer } from "../redis";
export type SocketChannel = {
    updatedAt: string;
    value: string[];
};
export declare class SocketManager {
    readonly redis: RedisServer;
    readonly websocket: WebSocketServer;
    private modelRedis;
    static instance: SocketManager;
    constructor(redis: RedisServer, websocket: WebSocketServer);
    static getInstance(redis: RedisServer, websocket: WebSocketServer): SocketManager;
    addSocketToChannel(socketId: string, channels: string[]): Promise<void>;
    removeSocketFromChannel(socketId: string, channels: string[]): Promise<void>;
    broadcastToChannel(channel: string, data: string): Promise<void>;
}
